RegisterCommand("spawnanimal", function(source, args)
    local model = GetHashKey("a_c_buck_01")
    local ped = PlayerPedId()
    RequestModel(model)
    while not HasModelLoaded(model) do
        Wait(1)
    end
    print(GetPointInFrontOfXYZA(GetEntityCoords(ped) - vector3(0.0, 0.0, 1.0), GetEntityHeading(ped), 2.5))
    local animal = CreatePed(model, GetPointInFrontOfXYZA(GetEntityCoords(ped) - vector3(0.0, 0.0, 1.0),
        GetEntityHeading(ped), 2.5), 0, true, false, 0, 0)
    print(animal)
    Citizen.InvokeNative(0x283978A15512B2FE, animal, true)
    FreezeEntityPosition(animal, true)
    SetEntityHealth(animal, 0)
end)

function GetPointInFrontOfXYZA(coords, a, dist)
    local x = coords.x + dist * math.sin(math.rad(-a))
    local y = coords.y + dist * math.cos(math.rad(-a))
    return vector3(x, y, coords.z)
end

RegisterCommand("requestcontrol", function(source, args)
    local animal = FindAnimal()
    if not animal then
        return
    end
    NetworkRequestControlOfEntity(animal)
end)

RegisterCommand("setculling", function(source, args)
    TriggerServerEvent("setculling")
end)

function FindAnimal()

    local itemSet = CreateItemset(true)
    local coords = GetEntityCoords(PlayerPedId())
    local model = GetHashKey("a_c_buck_01")

    local size = Citizen.InvokeNative(0x59B57C4B06531E1E, coords.x, coords.y, coords.z, 15.0, itemSet, 1,
        Citizen.ResultAsInteger())

    if size > 0 then
        for index = 0, size - 1 do
            local entity = GetIndexedItemInItemset(index, itemSet)
            if GetEntityModel(entity) == model then
                DestroyItemset(itemSet)
                return entity
            end
        end
    end

    print("ANIMAL NOT FOUND")
    return false
end
